package com.huanshao.bmap_flutter

import androidx.annotation.NonNull
import com.baidu.mapapi.CoordType
import com.baidu.mapapi.SDKInitializer
import com.huanshao.bmap_flutter.method_channel_handlers.MapStatusChangeListener
import com.huanshao.bmap_flutter.method_channel_handlers.PickLocationGetLocationHandler
import com.huanshao.bmap_flutter.method_channel_handlers.SearchLocationHandler

import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.EventChannel
import io.flutter.plugin.common.MethodChannel
class BmapFlutterPlugin: FlutterPlugin {
  /*监听地图*/
  private lateinit var registerMapStatusChangeListenerEventChannel: EventChannel
  /*获取当前位置*/
  /*地址搜索*/
  private lateinit var searchLocation: MethodChannel

  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    registerMapStatusChangeListenerEventChannel = EventChannel(flutterPluginBinding.binaryMessenger,
      "listen-map-status-change"
    )

    Consts.pickLocationGetLocation = MethodChannel(flutterPluginBinding.binaryMessenger, "pick-location-get-location")
  Consts.pickLocationGetLocation.setMethodCallHandler(PickLocationGetLocationHandler(context = flutterPluginBinding.applicationContext))

    registerMapStatusChangeListenerEventChannel.setStreamHandler(MapStatusChangeListener)

    searchLocation = MethodChannel(flutterPluginBinding.binaryMessenger, "search-location")
    searchLocation.setMethodCallHandler(SearchLocationHandler)

    SDKInitializer.initialize(flutterPluginBinding.applicationContext)
    SDKInitializer.setCoordType(CoordType.GCJ02)

    flutterPluginBinding.platformViewRegistry.registerViewFactory("bmap-view", NativeViewFactory())
  }

  override fun onDetachedFromEngine(binding: FlutterPlugin.FlutterPluginBinding) {
    registerMapStatusChangeListenerEventChannel.setStreamHandler(null)
    Consts.pickLocationGetLocation.setMethodCallHandler(null)
    searchLocation.setMethodCallHandler(null)
  }
}
