package com.huanshao.bmap_flutter

import android.content.Context
import android.view.View
import com.baidu.mapapi.map.TextureMapView
import io.flutter.plugin.platform.PlatformView

class NativeView(context: Context, id: Int, creationParams: Map<String?, Any?>?) : PlatformView {
    private val mapView = TextureMapView(context);

    override fun getView(): View {
        return mapView;
    }

    override fun dispose() {
        mapView.onDestroy()
    }

    init {
        Consts.mapView = mapView.map
        mapView.showZoomControls(false)
        mapView.map.uiSettings.setEnlargeCenterWithDoubleClickEnable(true)
        mapView.map.uiSettings.isRotateGesturesEnabled = false
        mapView.setPadding(0, 0, 0, 100)
    }

}