part of bmap_flutter;

class _ConfirmButtonStyle extends ButtonStyle {
  final BuildContext context;
  _ConfirmButtonStyle({required this.context});

  Color _getForegroundColor(Set<MaterialState> states) {
    return Colors.white;
  }

  Color _getBackgroundColor(Set<MaterialState> states) {
    return Theme.of(context).primaryColor;
  }

  Color _getOverlayColor(Set<MaterialState> states) {
    final activeStates = <MaterialState>{
      MaterialState.focused,
      MaterialState.hovered,
      MaterialState.pressed
    };

    if (states.any(activeStates.contains)) {
      return Colors.white.withOpacity(.35);
    }

    return Colors.transparent;
  }

  @override
  MaterialStateProperty<Color?>? get foregroundColor =>
      MaterialStateProperty.resolveWith((_getForegroundColor));

  @override
  MaterialStateProperty<Color?>? get backgroundColor =>
      MaterialStateProperty.resolveWith(_getBackgroundColor);

  @override
  MaterialStateProperty<Color?>? get overlayColor =>
      MaterialStateProperty.resolveWith(_getOverlayColor);
}
