part of bmap_flutter;

class PoiModel {
  final String name;
  final String address;
  final double latitude;
  final double longitude;

  PoiModel(
      {required this.name,
      required this.address,
      required this.latitude,
      required this.longitude});

  factory PoiModel.fromJson(Map<String, dynamic> mapData) =>
      _$PoiModelFromJson(mapData);

  @override
  String toString() {
    return "$name, $address, $latitude, $longitude";
  }
}

PoiModel _$PoiModelFromJson(Map<String, dynamic> mapData) {
  return PoiModel(
      name: mapData["name"],
      address: mapData["address"],
      latitude: mapData["latitude"],
      longitude: mapData["longitude"]);
}

List<PoiModel> _$PoiListFromJson(String jsonData) {
  final List<dynamic> list = json.decode(jsonData);

  return (() sync* {
    for (var item in list) {
      yield PoiModel.fromJson(item);
    }
  }())
      .toList();
}
